#property copyright "Martin-SAR (c) HotFx 2012.06.15"
#property link "http://hot-fx.blogspot.com" // http://hotfx.0pk.ru

extern double SAR         = 0.002;
extern double MinStep     = 46.0;
extern double Multiplier  = 1.6;
extern double MaxOrders   = 100;
extern double LotSize     = 0.1;
extern int    Slippage    = 2;
extern color  Bcol        = Blue;
extern color  Scol        = Red;

string symb; int per; datetime bt = 0; double ab, diff, MyPoint, LotDigits; bool visual = FALSE;

void init()
 {
  symb = Symbol(); LotDigits = MathLog(MarketInfo(symb, MODE_LOTSTEP)) / MathLog(0.1);
  MyPoint = Point; if (Digits == 5 || Digits == 3) { MyPoint *= 10; Slippage *= 10; }
  per = Period(); ab = AccountBalance(); diff = 0; MinStep *= MyPoint;
  if ((!IsTesting() && !IsOptimization()) || IsVisualMode())
   {
    visual = TRUE; ObjectCreate("tAP", OBJ_LABEL, 0, 0, 0);  ObjectSet("tAP", OBJPROP_COLOR, Black);
    ObjectSet("tAP", OBJPROP_CORNER, 1); ObjectSet("tAP", OBJPROP_XDISTANCE, 15); ObjectSet("tAP", OBJPROP_YDISTANCE, 20);
   } 
 } 

void start()
 {
  if (visual)
   {
    double ap = AccountProfit(), acEQ = AccountEquity(), tmp = AccountBalance();

    ObjectSetText("tAP", DoubleToStr(ap, 2), 19, "Impact");
    if (ap < 0) ObjectSet("tAP", OBJPROP_COLOR, DarkOrange);
    else ObjectSet("tAP", OBJPROP_COLOR, Lime);

    if (ab != tmp) { diff = tmp - ab; ab = tmp; }

    Comment("\n ", symb, "-", per, "     ab ", tmp, "     lst ", diff, "     cr% ", MathRound(acEQ / tmp * 100),
            "     lot ", LotSize, "     eq ", acEQ, "     ap ", ap, "     sp ", (Ask - Bid) / MyPoint);
   }          
    
  if (bt == Time[1]) return;

  int bor = 0, sor = 0; double bst = 0, sst = 0, lotB, lotS;
  for (int i = OrdersTotal() - 1; i >= 0; i --)
   if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) return;
   else
    {  
     double oprc = OrderOpenPrice(); int otyp = OrderType();
     if (otyp == OP_BUY) { bor ++; if (bst == 0 || oprc < bst) { bst = oprc; lotB = OrderLots(); } } 
     if (otyp == OP_SELL){ sor ++; if (sst == 0 || oprc > sst) { sst = oprc; lotS = OrderLots(); } }
    } 
  
  double sar1 = iSAR(symb, 0, SAR, 0.2, 1);      
  
  if (AccountProfit() > 0 && ((Close[1] < sar1 && bor != 0) || (Close[1] > sar1 && sor != 0))) { CloseALL(); bor = 0; bst = 0; sor = 0; sst = 0; }
      
  RefreshRates();
  
  if (Close[1] > sar1 && bst != 0 && bst - Ask > MinStep && bor < MaxOrders)
   if (OrderSend(symb, OP_BUY, NL(lotB * Multiplier), ND(Ask), Slippage, 0, 0, "", 0, 0, Bcol) == -1) return;
   
  if (Close[1] > sar1 && bor == 0) 
   if (OrderSend(symb, OP_BUY, LotSize, ND(Ask), Slippage, 0, 0, "", 0, 0, Bcol) == -1) return;

  if (Close[1] < sar1 && sst != 0 && Bid - sst > MinStep && sor < MaxOrders)
   if (OrderSend(symb, OP_SELL, NL(lotS * Multiplier), ND(Bid), Slippage, 0, 0, "", 0, 0, Scol) == -1) return;
   
  if (Close[1] < sar1 && sor == 0)
   if (OrderSend(symb, OP_SELL, LotSize, ND(Bid), Slippage, 0, 0, "", 0, 0, Scol) == -1) return;

  bt = Time[1];
 } //start

double ND(double value) { return (NormalizeDouble(value, Digits)); }
double NL(double value) { return (NormalizeDouble(value, LotDigits)); }

void CloseALL()
 {
  bool err = TRUE; while(err)
   {
    err = FALSE; for (int i = OrdersTotal() - 1; i >= 0; i --)
     if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) err = TRUE;
     else
      {
       int otyp = OrderType(); RefreshRates();
       if (otyp == OP_BUY) if (!OrderClose(OrderTicket(), OrderLots(), ND(Bid), Slippage, Bcol)) err = TRUE;
       if (otyp == OP_SELL) if (!OrderClose(OrderTicket(), OrderLots(), ND(Ask), Slippage, Scol)) err = TRUE;
      } 
   }  
 }

